<?php

/*
Plugin Name: Simple Speed
Plugin URI: http://rynaldo.com
Description: Simple Speed is a stable and powerful plugin that dramatically increases your page speed and performance without any hassle. Simply activate and enjoy - no configuration needed! Uses GZIP compression, leverages browser caching, includes automatic hotlink protection and much more.  
Author: Rynaldo
Author URI: http:rynaldo.com
Version: 1.5
*/

/*
  Copyright 2015  Rynaldo Stoltz

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
 
require_once('functions.php');
require_once('compression.php');

global $super_simple_speed;
global $hotlink;
global $hta1;
global $hta2;
global $hta3;
global $hta4;
global $hta5;
global $hta6;
global $hta7;
global $hta8;


$url = strtolower(get_bloginfo('url'));
$url = str_replace('https://','',$url);
$url = str_replace('http://','',$url);
$url = str_replace('www.','',$url);

$hotlink = "

# WP Super Simple Speed by Rynaldo Starts

# Hotlink Protection Start

RewriteEngine on
RewriteCond %{HTTP_REFERER} !^$
RewriteCond %{HTTP_REFERER} !^http(s)?://(www\.)?".$url." [NC]
RewriteCond %{HTTP_REFERER} !^http(s)?://(www\.)?google.com [NC]
RewriteRule \.(jpg|jpeg|png|gif)$ - [NC,F,L]

";

	$hta1 .= '# GZIP Compression Start'."\r\n"."\r\n";
	$hta1 .= '<IfModule mod_deflate.c>'."\r\n";
	$hta1 .= 'AddOutputFilterByType DEFLATE text/plain'."\r\n";
	$hta1 .= 'AddOutputFilterByType DEFLATE text/html'."\r\n";
	$hta1 .= 'AddOutputFilterByType DEFLATE text/xml'."\r\n";
	$hta1 .= 'AddOutputFilterByType DEFLATE text/css'."\r\n";
	$hta1 .= 'AddOutputFilterByType DEFLATE application/xml'."\r\n";
	$hta1 .= 'AddOutputFilterByType DEFLATE application/xhtml+xml'."\r\n";
	$hta1 .= 'AddOutputFilterByType DEFLATE application/rss+xml'."\r\n";
	$hta1 .= 'AddOutputFilterByType DEFLATE application/javascript'."\r\n";
	$hta1 .= 'AddOutputFilterByType DEFLATE application/x-javascript'."\r\n";
	$hta1 .= 'AddOutputFilterByType DEFLATE application/x-httpd-php'."\r\n";
	$hta1 .= 'AddOutputFilterByType DEFLATE application/x-httpd-fastphp'."\r\n";
	$hta1 .= 'AddOutputFilterByType DEFLATE image/svg+xml'."\r\n";
	$hta1 .= 'BrowserMatch ^Mozilla/4 gzip-only-text/html'."\r\n";
	$hta1 .= 'BrowserMatch ^Mozilla/4\.0[678] no-gzip'."\r\n";
	$hta1 .= 'BrowserMatch \bMSI[E] !no-gzip !gzip-only-text/html'."\r\n";
	$hta1 .= 'Header append Vary User-Agent env=!dont-vary'."\r\n";
	$hta1 .= '</IfModule>'."\r\n"."\r\n";

	$hta2 .= '# Leverage Browser Caching Start'."\r\n"."\r\n";
	$hta2 .= '<IfModule mod_expires.c>'."\r\n";
	$hta2 .= 'ExpiresActive On'."\r\n";
	$hta2 .= 'ExpiresByType image/jpg "access 1 year"'."\r\n";
	$hta2 .= 'ExpiresByType image/jpeg "access 1 year"'."\r\n";
	$hta2 .= 'ExpiresByType image/gif "access 1 year"'."\r\n";
	$hta2 .= 'ExpiresByType image/png "access 1 year"'."\r\n";
	$hta2 .= 'ExpiresByType text/css "access 1 month"'."\r\n";
	$hta2 .= 'ExpiresByType text/x-javascript "access 1 month"'."\r\n";
	$hta2 .= 'ExpiresDefault "access 1 month"'."\r\n";
	$hta2 .= '</IfModule>'."\r\n"."\r\n";
	
	$hta3 .= '# Caching of common files Start'."\r\n"."\r\n";
	$hta3 .= '<IfModule mod_headers.c>'."\r\n";
	$hta3 .= '<FilesMatch "\.(ico|pdf|flv|swf|js|css|gif|png|jpg|jpeg|ico|txt|html|htm)$">'."\r\n";
	$hta3 .= 'Header set Cache-Control "max-age=2592000, public"'."\r\n";
	$hta3 .= '</FilesMatch>'."\r\n";
	$hta3 .= '</IfModule>'."\r\n"."\r\n";

	$hta4 .= '# Enable Keepalive Start'."\r\n"."\r\n";
	$hta4 .= '<ifModule mod_headers.c>'."\r\n";
	$hta4 .= 'Header set Connection keep-alive'."\r\n";
	$hta4 .= '</ifModule>'."\r\n"."\r\n";
	
	$hta5 .= '# Use UTF-8 encoding Start'."\r\n"."\r\n";
	$hta5 .= 'AddDefaultCharset utf-8'."\r\n"."\r\n";
	
	$hta6 .= '# Enable Vary: Accept-Encoding Start'."\r\n"."\r\n";
	$hta6 .= '<IfModule mod_headers.c>'."\r\n";
	$hta6 .= '<FilesMatch "\.(js|css|xml|gz)$">'."\r\n";
	$hta6 .= 'Header append Vary: Accept-Encoding'."\r\n";
	$hta6 .= '</FilesMatch>'."\r\n";
	$hta6 .= '</IfModule>'."\r\n"."\r\n";

	$hta7 .= '# Enable mod_pagespeed Start'."\r\n"."\r\n";
	$hta7 .= '<IfModule pagespeed_module>'."\r\n";
	$hta7 .= 'ModPagespeed on'."\r\n";
	$hta7 .= 'ModPagespeedEnableFilters rewrite_css,combine_css'."\r\n";
	$hta7 .= 'ModPagespeedEnableFilters recompress_images'."\r\n";
	$hta7 .= 'ModPagespeedEnableFilters convert_png_to_jpeg,convert_jpeg_to_webp'."\r\n";
	$hta7 .= 'ModPagespeedEnableFilters collapse_whitespace,remove_comments'."\r\n";
	$hta7 .= '</IfModule>'."\r\n"."\r\n";


	$hta8 .= '# WP Super Simple Speed by Rynaldo Ends'."\r\n"."\r\n";

$super_simple_speed = ABSPATH.'.htaccess';

function wpss_activate() {
	global $super_simple_speed;
	global $hotlink;
	global $hta1;
	global $hta2;
	global $hta3;
	global $hta4;
	global $hta5;
	global $hta6;
	global $hta7;
	global $hta8;

	if (file_exists($super_simple_speed)) {

		$fh = fopen($super_simple_speed, 'r');
		$htaccess = fread($fh, filesize($super_simple_speed));
		fclose($fh);
  	}

	$fh = fopen($super_simple_speed, 'w') or die("can't open file");
	fwrite($fh, $htaccess.$hotlink);
	fwrite($fh, $hta1);
	fwrite($fh, $hta2);
	fwrite($fh, $hta3);
	fwrite($fh, $hta4);
	fwrite($fh, $hta5);
	fwrite($fh, $hta6);
	fwrite($fh, $hta7);
	fwrite($fh, $hta8);
	fclose($fh);
}

register_activation_hook( __FILE__, 'wpss_activate' );

function wpss_deactivate() {
	global $super_simple_speed;
	global $hotlink;
	global $hta1;
	global $hta2;
	global $hta3;
	global $hta4;
	global $hta5;
	global $hta6;

	if (file_exists($super_simple_speed)) {

		$fh = fopen($super_simple_speed, 'r');
		$htaccess = fread($fh, filesize($super_simple_speed));
		fclose($fh);

		$htaccess = str_replace($hotlink, "", $htaccess);
		$htaccess = str_replace($hta1, "",$htaccess);
		$htaccess = str_replace($hta2, "",$htaccess);
		$htaccess = str_replace($hta3, "",$htaccess);
		$htaccess = str_replace($hta4, "",$htaccess);
		$htaccess = str_replace($hta5, "",$htaccess);
		$htaccess = str_replace($hta6, "",$htaccess);
		$htaccess = str_replace($hta7, "",$htaccess);
		$htaccess = str_replace($hta8, "",$htaccess);

		$fh = fopen($super_simple_speed, 'w') or die("can't open file");
		fwrite($fh, $htaccess);
		fclose($fh);
	}
}

register_deactivation_hook( __FILE__, 'wpss_deactivate' );

?>